# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc批量导入商品验证_返利发放管理,2271,2271-36,sit,bs
主数据平台:运营后台管理系统返利发放商品批量导入接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import json
import os
import random

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers_file", cmdc_access_token)

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/批量导入商品模板.xlsx"

# 第二步获取产品线商品信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url15")
request_body = commonFuc().get_business_data(module, "payload15")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成一个随机数字，用于后续随机选择商品
product_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取产品线商品列表中商品信息
product_name = result["data"]["list"][product_random]["relevanceName"]
product_code = result["data"]["list"][product_random]["relevanceCode"]

# 将商品信息写入导入模板中
excel = HandleExcel(file_path, "Sheet1")
excel.write_data(row=2, column=1, value=product_code)
excel.write_data(row=2, column=2, value=product_name)

# 第四步，进行文件导入操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url41")

# 获取文件
file = open(file_path, "rb")
files = {"file": file}

"""
场景: 批量导入商品验证_返利发放管理
用例名称：批量导入商品验证_返利发放管理
输出：{"productCode":"%s"}
"""
# 发送请求
result = requests.post(url, files=files, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)
# print(result)
file.close()
result = {"productCode": result["data"][0]["productCode"]}
result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict41", product_code)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
