# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc返利使用明细导出验证,2271,2271-55,sit,bs
主数据平台:后台运营系统返利使用明细导出接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import os


module = "cmdc_rebate"

# 第一步登录后台运营系统获取token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第三步订单发货明细导出操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url44")
request_body = commonFuc().get_business_data(module, "payload44")
# print(request_body)
"""
 场景: 返利使用明细导出验证
 用例名称：返利使用明细导出验证
 输出：{"customerCode":"1000086"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/返利明细.xlsx"

# 获取到导出文件存入cmdc_files文件中
with open(file_path, 'wb') as f:
    f.write(result.content)

# 获取文件中客户编码
excel = HandleExcel(file_path, "Sheet1")
# print(excel.read_data())
result = {"customerCode": excel.read_data()[0].get("客户编码")}
# print(result)
result["api_time"] = api_time
# print(result)
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict44")
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
