# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc查询条件验证_发票清单列表,2294,2294-37,sit,be
主数据平台:多采商城获取发票清单列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.多采商城登录.多采商城登录 import CmdcMaiiLogin
import random
import requests
import datetime
import json

module = "cmdc_trade"

# 第一步获取登录多采商城所需账号密码
username = commonFuc().get_business_data(module, "username_be")
password = commonFuc().get_business_data(module, "password_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcMaiiLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers1", cmdc_access_token)

# 第二步获取发票清单列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url35")
request_body = commonFuc().get_business_data(module, "payload35")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
print(result)
# 生成随机数
invoice_random = random.randint(2, len(result["data"]["list"]) - 1)
# 获取发票信息
# print(invoice_random)
invoice_no = result["data"]["list"][invoice_random]["invoiceNo"]
invoice_time_begin = result["data"]["list"][invoice_random]["invoiceTime"].replace("/", "-") + " 00:00:00"
invoice_time_end = datetime.datetime.now().strftime("%Y-%m-%d 23:59:59")
company_ode = result["data"]["list"][invoice_random]["companyCode"]
demand_parent_code = result["data"]["list"][invoice_random]["demandParentCode"]

# 第三步进行查询条件验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url36")
request_body = commonFuc().get_business_data(module, "payload36", invoice_no, invoice_time_begin, invoice_time_end,
                                             company_ode, demand_parent_code)
# print(request_body)
"""

 场景: 查询条件验证_发票清单列表
 用例名称：查询条件验证_发票清单列表
 输出：{"invoiceNo":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
# 获取查询结果中invoiceNo
result = json.loads(result.content)
# print(result)
result = {"invoiceNo": result["data"]["list"][0]["invoiceNo"]}

result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict36", invoice_no)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
